#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "resource.h"

//Prototypes
LRESULT CALLBACK Win32WMProc(HWND hWnd, UINT uMessage, WPARAM wparam, LPARAM lparam);
void main(void); //In Win32, main is not the entry point
int eject_media(char letter, int reload);
int ReadCD(int start, int count, char *buf);
int get_mdb_block_address( HANDLE hcd, int drive, long *start );
void CreateMainWindow(void);
void WaveInit(void);
void vMac_Beep(void);
void vMac_Message(char * Message);
int  dcheck(void);

void SetStatus(char * String);

/* Returns TRUE if same, otherwise it returns FALSE and copies Source to Dest */
BOOL FastMemCmpCpy(ULONG * Dest, ULONG * Source, ULONG Len);

#ifndef NO_VMAC_TYPES
  int Gemulator_LoadROM(UBYTE * NewROM, UWORD Base, UBYTE Socket, UBYTE Length);
#endif //NO_VMAC_TYPES

//Globals
HANDLE ModemPort,hModemThread;
char ModemData[256];
int ModemBytes,ModemCount,ReadModem;
int ModemThreadID;

HANDLE PrintPort,hPrintThread;
char PrintData[256];
int PrintBytes,PrintCount,ReadPrint;
int PrintThreadID;

HANDLE hFloppyThread;
int FloppyThreadID;

BOOL FloppyReady, FloppyBusy;

char PrefsFile[1024];
int UpdateScreen;
int ROMScreen;
BOOL ShowTraps;
BOOL Mac_Interrupt;
BOOL Mac_Reset;
RECT g_rcClient;
HWND hwndStatus;
BYTE MouseButton;
HINSTANCE AppInstance;
HWND MainWnd;
HDC MainWndDC;
HBITMAP ScreenBitmapH;
HDC ScreenBits;
int WndX;
int WndY;
WORD XBorder;
WORD YBorder;
WORD YMenu;
WORD YMenuSize;
BYTE UseFloppy;
BYTE CDdrive;
BYTE UseCD;
long start_address;
HANDLE hThread_CPU;
int    iThread_CPUID;
BOOL Int60, Int1;
int CyclesPerInterrupt;
int ScreenX, ScreenY;
BYTE vMacError;
char vMacPath[1024];

//
// DirectX Interface
//

//#define WIN32_LEAN_AND_MEAN

#ifdef __cplusplus
extern "C"
{
#endif

void DX_CleanBuffers();

// Initializes DirectX and switches the video mode to the given parameters
//
BOOL DX_Init(HWND hwndMain, int iScreenX, int iScreenY, int iBPP);

// Restore the original video mode and delete the DirectX objects
//
void DX_End();

void DX_SetPage(int iPage);

void DX_Lock();
void DX_Unlock();

void DX_WriteByte(DWORD dwOffset, BYTE by);
void DX_WriteWord(DWORD dwOffset, WORD wWord);
void DX_WriteLong(DWORD dwOffset, LONG lLong);

void UpdateDXScreen(BOOL Temp);
void DxHideCursor(BOOL Temp);

// Takes a pointer to the Mac's 512x342 screen memory and draws it
// centered on the screen
//
BOOL DX_DrawBW(BYTE *pbyScreen);

// Call this before doing any GDI functions that need to be immediately visible
//
void DX_GDI();
void DX_GDIEnd();

// Show or hide a framerate counter.  I couldn't resist :)
//
void DX_FrameCounter(BOOL bShow);

#ifdef __cplusplus
}
#endif

//1.4MB Mac floppy reading/writing code for Win32
//Written by Lauri Pesonen
//Modifications for vMac Win32 by Weston Pawlowski

#define MAX_FLOPPIES 2

#ifdef __cplusplus
extern "C" {
#endif

void dinit(void);
void dfinal(void);

void floppy_final( int drive );
HANDLE floppy_init( int drive, BOOL check_geometry );
int floppy_read( HANDLE hFloppy, int drive, int LBA, int count, char *buf );
int floppy_write( HANDLE hFloppy, int drive, int LBA, int count, char *buf );
void floppy_get_geometry(
	int drive,
	int *pC, int *pH, int *pS, int *psector_size
);

long get_floppy_size( HANDLE hfloppy, int drive );

void floppy_module_global_init( void );
void floppy_module_global_final( void );

int get_floppy_max_size( int drive );

int is_any_floppy_present( int drive );
int is_hfs_floppy_present( int drive );

int silencer( int shutup );

void clear_cache_by_drive_index( int drive );

int exists( char *path );

#ifdef __cplusplus
} // extern "C"
#endif

#define NBLOCKS 200

typedef struct {
	int inited;
	int res_count;
	int sector_size;
	char *blocks;
	int block[NBLOCKS];
	DWORD LRU[NBLOCKS];
} cachetype;

void cache_init( cachetype *cptr );
void cache_clear( cachetype *cptr );
void cache_final( cachetype *cptr );
int cache_get( cachetype *cptr, int block, char *buf );
void cache_put( cachetype *cptr, int block, char *buf, int ss );
void cache_remove( cachetype *cptr, int block, int ss );

//CD-ROM code for Windows NT

//CDEnable.H
/*
		cdenable.sys driver for Windows NT 4.0 and upwards
		11/15/1997 Lauri Pesonen
*/

// max read requests, if larger -> STATUS_INVALID_PARAMETER
#define CDENABLE_MAX_TRANSFER_SIZE (0x10000)


// A structure representing the instance information associated with
// a particular device
typedef struct _DEVICE_EXTENSION
{
  ULONG  StateVariable;
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;


// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-32767, and 32768-65535 are reserved for use
// by customers.
#define FILE_DEVICE_CDENABLE  0x00008301


// Target NT version, internal version
#define CDENABLE_CURRENT_VERSION  0x04000100


// Macro definition for defining IOCTL and FSCTL function control codes.  Note
// that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers.
#define CDENABLE_IOCTL_READ						0x830
#define CDENABLE_IOCTL_GET_VERSION		0x831


#define IOCTL_CDENABLE_READ         CTL_CODE(FILE_DEVICE_CDENABLE,  \
                                             CDENABLE_IOCTL_READ,  \
                                             METHOD_BUFFERED,       \
                                             FILE_ANY_ACCESS)
#define IOCTL_CDENABLE_GET_VERSION  CTL_CODE(FILE_DEVICE_CDENABLE,  \
                                             CDENABLE_IOCTL_GET_VERSION,  \
                                             METHOD_BUFFERED,       \
                                             FILE_ANY_ACCESS)

//NTCD.H

/*
		Interface to cdenable.sys driver.
		11/15/1997 Lauri Pesonen
*/


/*
		Installs the driver, if not already installed.
		Starts the driver, if not already running.

		You can either always call "CdenableSysInstallStart" when your
		program fires up and "CdenableSysStopRemove" when it terminates,
		or just let the installation program call "CdenableSysInstallStart"
		and leave it always be present.

		I recommend the latter option. Calling "CdenableSysInstallStart"
		always doesn't hurt anything, it will immediately return
		with success if the service is running.

		Returns non-zero if installation/startup was succesfull,
		zero if anything failed.
		Returns non-zero also if the driver was already running.

		The file "cdenable.sys" must already have been copied to
		the directory "System32\Drivers"
*/
BOOL CdenableSysInstallStart(void);


/*
		Stops and removes the driver. See above.
		This must be called when new version of the driver is updated.
*/
void CdenableSysStopRemove(void);


/*
		HANDLE h: returned from CreateFile ( "\\\\.\\X:", GENERIC_READ, ... );
		Returns the bytes actually read (==count), 0 on failure.
		NOTE: in my code, start and count are always aligned to
		sector boundaries (2048 bytes).
		I cannot guarantee that this works if they are not.
		Max read is 64 kb.
		Synchronous read, but quite fast.
*/
int CdenableSysReadCdBytes( HANDLE h, DWORD start, DWORD count, char *buf );


/*
		Same as SysReadCdBytes, but "start" and "count" are in 2048 byte
		sectors.
*/
int CdenableSysReadCdSectors( HANDLE h, DWORD start, DWORD count, char *buf );


/*
		Returns CDENABLE_CURRENT_VERSION (of the driver).
*/
DWORD CdenableSysGetVersion( void );

//End CD-ROM code for Windows NT
